%define tarname apache-couchdb
%define couchdb_user couchdb

Name:           couchdb
Version:        0.8.1
Release:        1%{?dist}
Summary:        A document database server, accessible via a RESTful JSON API

Group:          Applications/Databases
License:        ASL 2.0
URL:            http://incubator.apache.org/couchdb/
Source0:       http://www.apache.org/dist/incubator/%{name}/%{version}-incubating/%{tarname}-%{version}-incubating.tar.gz
Source1:        couchdb.init
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  erlang libicu-devel js-devel help2man
Requires:       erlang %{_bindir}/icu-config

#Initscripts
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts

# Users and groups
Requires(pre): shadow-utils


%description
Apache CouchDB is a distributed, fault-tolerant and schema-free 
document-oriented database accessible via a RESTful HTTP/JSON API. 
Among other features, it provides robust, incremental replication 
with bi-directional conflict detection and resolution, and is 
queryable and indexable using a table-oriented view engine with 
JavaScript acting as the default view definition language.

%prep
%setup -q -n %{tarname}-%{version}-incubating


%build
%configure
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_initrddir}/couchdb
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/couchdb
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run/couchdb
# Modify local of couchdb.pid
sed -i 's/\/var\/run\/couchdb.pid/\/var\/run\/couchdb\/couchdb.pid/g' $RPM_BUILD_ROOT%{_sysconfdir}/default/couchdb


%clean
rm -rf $RPM_BUILD_ROOT


%pre
getent group couchdb >/dev/null || groupadd -r couchdb
getent passwd couchdb >/dev/null || \
useradd -r -m -g couchdb -d /var/lib/couchdb -s /bin/bash \
-c "Couchdb Database Server" couchdb
exit 0


%post
/sbin/ldconfig
/sbin/chkconfig --add couchdb


%postun -p /sbin/ldconfig


%preun
if [ $1 = 0 ] ; then
    /sbin/service couchdb stop >/dev/null 2>&1
    /sbin/chkconfig --del couchdb
fi


%files
%defattr(-,root,root,-)
%doc AUTHORS BUGS CHANGES LICENSE NEWS NOTICE README THANKS
%dir %{_sysconfdir}/couchdb
%config(noreplace) %{_sysconfdir}/couchdb/couch.ini
%config(noreplace) %{_sysconfdir}/default/couchdb
%config(noreplace) %{_sysconfdir}/logrotate.d/couchdb
%exclude %{_sysconfdir}/rc.d/couchdb
%{_sysconfdir}/rc.d/couchdb
%{_initrddir}/couchdb
%{_bindir}/*
%dir %{_libdir}/couchdb
%{_libdir}/couchdb/*
%exclude %{_libdir}/couchdb/erlang/lib/couch-0.8.1-incubating/priv/lib/couch_erl_driver.la
%{_datadir}/couchdb/*
%exclude %{_datadir}/doc/couchdb/*
%{_mandir}/man1/*
%dir %attr(0755, %{couchdb_user}, root) %{_localstatedir}/log/couchdb
%dir %attr(0755, %{couchdb_user}, root) %{_localstatedir}/run/couchdb

%changelog

* Tue Nov 25 2008 Allisson Azevedo <allisson@gmail.com> 0.8.1-1
- Initial RPM release
